#include <array>
#include <cmath>

#include "App.hpp"
#include "Math.hpp"
#include "values/mrand.hpp"

#include <raylib.h>
#include <raymath.h>

void App::init(int screenWidth, int screenHeight)
{
  this->screenWidth = screenWidth;
  this->screenHeight = screenHeight;
  this->canvas.init(screenWidth);

  mrand::setSeed(1);

  canvasTexure = LoadRenderTexture(screenWidth, screenWidth);

  newDna(dna);
  canvas.newGen(canvasTexure, &dna);

  float posY = (screenHeight - screenWidth) / 2.0f;
  dest = {0, posY, (float)screenWidth, (float)screenWidth};
}

void App::update()
{
  if (IsMouseButtonPressed(MOUSE_BUTTON_LEFT))
  {
    newDna(dna);
    canvas.newGen(canvasTexure, &dna);
  }
}

void App::draw()
{
  ClearBackground(RED);

  Rectangle source = {0, 0, (float)canvasTexure.texture.width, (float)-canvasTexure.texture.height};
  Vector2 origin = {0.0f, 0.0f};
  DrawTexturePro(canvasTexure.texture, source, dest, origin, 0.0f, WHITE);
}

void App::deinit()
{

  UnloadRenderTexture(canvasTexure);

  canvas.deinit();
}